Subject: bug#62009: 29.0.60; Emacs crashes on setf symbol-name

From: Augusto Stoffel <[email-masked]>
Date: Fri, 10 Mar 2023 12:23:54 +0100

On Fri, 10 Mar 2023 at 12:09, Daniel Mendler wrote:

> On 3/10/23 11:59, Gregory Heytings wrote:
>> That would also come with a performance overhead, as there is currently no 
>> way to distinguist strings that are used for symbol names from other 
>> strings.  Not to mention the added complexity in the code.
>
> One could check if the string is located in read-only memory. Or one
> could add a flag bit to the string data structure (and possibly to other
> data structures too). Freezing data structures such that they become
> read-only is a generally useful feature. There won't be any performance
> overhead of the check since a branch not taken is fast thanks to the
> branch predictor.

Note also that in-place modification of strings is arbitrarily costly,
cf. (aset "ascii" 0 ?😼).  Not to mention that it's rarely a good or
necessary move to make, as far as programming style is concerned.